using System.Diagnostics;
using System;
using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using Microsoft.VisualBasic;
using System.Data;
using System.Collections.Generic;
using Microsoft.VisualBasic.CompilerServices;

namespace Best_ZYX_MLR
{
	public class CResults
	{
		
		private int m_nResCount;
		private TypeModule.ResType[] m_uResRec;
		
		public CResults()
		{
			m_nResCount = 0;
		}
		
		public void Add(string sModel, double fR2, double fSlope1, double fSlope2, double fIntercept, string sErr)
		{
			m_uResRec = (TypeModule.ResType[]) Microsoft.VisualBasic.CompilerServices.Utils.CopyArray((Array) m_uResRec, new TypeModule.ResType[m_nResCount+1 + 1]);
			
			m_uResRec[m_nResCount].m_sModel = sModel;
			m_uResRec[m_nResCount].m_fR2 = fR2;
			m_uResRec[m_nResCount].m_fSlope1 = fSlope1;
			m_uResRec[m_nResCount].m_fSlope2 = fSlope2;
			m_uResRec[m_nResCount].m_fIntercept = fIntercept;
			m_uResRec[m_nResCount].m_sErr = sErr;
			m_nResCount++;
		}
		
		public void Clear()
		{
			m_nResCount = 0;
		}
		
		public int Count()
		{
			return m_nResCount;
		}
		
		public string GetModel(int nIndex)
		{
			return (nIndex > - 1 && nIndex < m_nResCount ? (m_uResRec[nIndex].m_sModel) : "");
		}
		
		public double GetR2(int nIndex)
		{
			return (nIndex > - 1 && nIndex < m_nResCount ? (m_uResRec[nIndex].m_fR2) : - 1);
		}
		
		public double GetSlope1(int nIndex)
		{
			return (nIndex > - 1 && nIndex < m_nResCount ? (m_uResRec[nIndex].m_fSlope1) : - 1.0E+30);
		}
		
		public double GetSlope2(int nIndex)
		{
			return (nIndex > - 1 && nIndex < m_nResCount ? (m_uResRec[nIndex].m_fSlope2) : - 1.0E+30);
		}
		
		public double GetIntercept(int nIndex)
		{
			return (nIndex > - 1 && nIndex < m_nResCount ? (m_uResRec[nIndex].m_fIntercept) : - 1.0E+30);
		}
		
		public string GetErr(int nIndex)
		{
			return (nIndex > - 1 && nIndex < m_nResCount ? (m_uResRec[nIndex].m_sErr) : "");
		}
		
		public void SortResults()
		{
			bool bInorder;
			int I;
			int J;
			int N;
			int nOffset;
			int nResetCounter;
			TypeModule.ResType uBuffer;
			
			N = m_nResCount;
			nOffset = N;
			nResetCounter = 0;
			do
			{
				nOffset = (5 * nOffset) / 11;
				if (nOffset == 0)
				{
					nOffset = 1;
				}
				bInorder = true;
				for (I = 0; I <= N - nOffset - 1; I++)
				{
					J = I + nOffset;
					if (m_uResRec[I].m_fR2 < m_uResRec[J].m_fR2)
					{
						uBuffer = m_uResRec[I];
						m_uResRec[I] = m_uResRec[J];
						m_uResRec[J] = uBuffer;
						bInorder = false;
					}
				}
				if (bInorder)
				{
					nResetCounter++;
				}
				if ((! bInorder) &&(nOffset == 1))
				{
					nOffset = N;
					for (I = 1; I <= nResetCounter; I++)
					{
						nOffset = (5 * nOffset) / 11;
					}
					if (nOffset == 0)
					{
						nOffset = 1;
					}
				}
			} while (!(nOffset == 1 && bInorder));
		}
	}
	
}
