using System.Diagnostics;
using System;
using System.Windows.Forms;
using System.Collections;
using System.Drawing;
using Microsoft.VisualBasic;
using System.Data;
using System.Collections.Generic;
using System.IO;


namespace Best_ZYX_MLR
{
	public partial class Form1
	{
		public Form1()
		{
			InitializeComponent();
		}
		
		private string sDataFilename;
		private bool bEditMode;
		private bool bTextHasChanged;
		
		private void cmdCalc_Click(System.Object sender, System.EventArgs e)
		{
			CStatSum objLR;
			CResults objRes;
			int I;
			int N;
			int nDataCount = 0;
			// 			int N;
			// 			int nDataCount;
			double[] fShiftArr = new double[4];
			double[] fScaleArr = new double[4];
			string sBuffer;
			
			if (sDataFilename == "")
			{
				MessageBox.Show("Please select a data file first", "Error", MessageBoxButtons.OK, MessageBoxIcon.Hand);
				return;
			}
			
			if (bTextHasChanged)
			{
				if (MessageBox.Show("Save changed data?", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
				{
					File.WriteAllText(sDataFilename, txtRes.Text);
				}
				bTextHasChanged = false;
			}
			bEditMode = false;
			
			if (txtMaxResults.Text.Length > 0)
			{
				N = int.Parse(txtMaxResults.Text);
				if (N < 1)
				{
					N = 32000;
				}
			}
			else
			{
				N = 32000;
			}
			
			objLR = new CStatSum();
			objRes = new CResults();
			
			// check the Shift Y text box
			if (txtShiftY.Text.Length > 0)
			{
				fShiftArr[0] = double.Parse(txtShiftY.Text);
			}
			else
			{
				fShiftArr[0] = 0;
			}
			
			// check the Shift X1 text box
			if (txtShiftX1.Text.Length > 0)
			{
				fShiftArr[1] = double.Parse(txtShiftX1.Text);
			}
			else
			{
				fShiftArr[1] = 0;
			}
			
			// check the Shift X2 text box
			if (txtShiftX2.Text.Length > 0)
			{
				fShiftArr[2] = double.Parse(txtShiftX2.Text);
			}
			else
			{
				fShiftArr[2] = 0;
			}
			
			// check the Scale Y text box
			if (txtScaleY.Text.Length > 0)
			{
				fScaleArr[0] = double.Parse(txtScaleY.Text);
				if (fScaleArr[0] == 0)
				{
					fScaleArr[0] = 1;
				}
			}
			else
			{
				fScaleArr[0] = 1;
			}
			
			// check the Scale X1 text box
			if (txtScaleX1.Text.Length > 0)
			{
				fScaleArr[1] = double.Parse(txtScaleX1.Text);
				if (fScaleArr[1] == 0)
				{
					fScaleArr[1] = 1;
				}
			}
			else
			{
				fScaleArr[1] = 1;
			}
			
			// check the Scale X2 text box
			if (txtScaleX2.Text.Length > 0)
			{
				fScaleArr[2] = double.Parse(txtScaleX2.Text);
				if (fScaleArr[2] == 0)
				{
					fScaleArr[2] = 1;
				}
			}
			else
			{
				fScaleArr[2] = 1;
			}
			
			if (objLR.GetData(sDataFilename, ref nDataCount, ref fShiftArr, ref fScaleArr))
			{
				Cursor = Cursors.WaitCursor;
				objLR.FindBestFit(ref objRes);
				objRes.SortResults();
				sBuffer = "Source Data File: " + sDataFilename + "\r\n" + "\r\n";
				sBuffer = sBuffer + "Date/Time: " + DateTime.Now+ "\r\n" + "\r\n";
				sBuffer = sBuffer + "Nnmber of observations = " + nDataCount + "\r\n" + "\r\n";
				if (fScaleArr[0] != 1)
				{
					sBuffer = sBuffer + "Scale Y = " + fScaleArr[0] + "\r\n";
				}
				if (fShiftArr[0] != 0)
				{
					sBuffer = sBuffer + "Shift Y = " + fShiftArr[0] + "\r\n";
				}
				if (fScaleArr[1] != 1)
				{
					sBuffer = sBuffer + "Scale X1 = " + fScaleArr[1] + "\r\n";
				}
				if (fShiftArr[1] != 0)
				{
					sBuffer = sBuffer + "Shift X1 = " + fShiftArr[1] + "\r\n";
				}
				if (fScaleArr[2] != 1)
				{
					sBuffer = sBuffer + "Scale X2 = " + fScaleArr[2] + "\r\n";
				}
				if (fShiftArr[2] != 0)
				{
					sBuffer = sBuffer + "Shift X2 = " + fShiftArr[2] + "\r\n";
				}
				N = objRes.Count() > N ? N : objRes.Count();
				for (I = 0; I <= N - 1; I++)
				{
					sBuffer = sBuffer + "R-Sqr = " + objRes.GetR2(I).ToString() + "\r\n";
					sBuffer = sBuffer + "Model: " + objRes.GetModel(I) + "\r\n";
					sBuffer = sBuffer + "A  = " + objRes.GetIntercept(I).ToString() + ", B1 = " + objRes.GetSlope1(I).ToString() + ", B2 = " + objRes.GetSlope2(I).ToString() + "\r\n";
				}
				txtRes.Text = sBuffer;
				sBuffer = "";
				Cursor = Cursors.Default;
				cmdSaveRes.Enabled = true;
			}
			else
			{
				MessageBox.Show("Error in processing data", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
		
		private void Form1_Load(System.Object sender, System.EventArgs e)
		{
			sDataFilename = "";
			cmdCalc.Enabled = false;
			cmdSaveRes.Enabled = false;
			bEditMode = false;
		}
		
		private void cmdReadData_Click(System.Object sender, System.EventArgs e)
		{
			dlgReadData.Filter = "All files (*.*)|*.*|Text files|*.txt|Data files (*.dat)|*.dat";
			if (dlgReadData.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				sDataFilename = dlgReadData.FileName;
				txtRes.Text = File.ReadAllText(sDataFilename);
				cmdCalc.Enabled = true;
				cmdSaveRes.Enabled = true;
				bTextHasChanged = false;
				bEditMode = true;
			}
		}
		
		private void cmdSaveRes_Click(System.Object sender, System.EventArgs e)
		{
			dlgSaveRes.Filter = "All files (*.*)|*.*|Text files|*.txt|Data files (*.dat)|*.dat";
			if (dlgSaveRes.ShowDialog() == System.Windows.Forms.DialogResult.OK)
			{
				File.WriteAllText(dlgSaveRes.FileName, txtRes.Text);
				bTextHasChanged = false;
			}
		}
		
		private void cmdClose_Click(System.Object sender, System.EventArgs e)
		{
			if (MessageBox.Show("Close application?", "Confirmation", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
			{
				Close();
			}
		}
		
		private void txtRes_TextChanged(System.Object sender, System.EventArgs e)
		{
			if (bEditMode)
			{
				bTextHasChanged = true;
			}
		}
		
		        private void cmdHelp_Click(System.Object sender, System.EventArgs e)
        {
            string sText;
            double x1, x2, x3;
            int i;
            Random r = new Random();

            sText = "Each line can be 1) empty, 2) a comment line or 3) a data line" + "\r\n" + 
                    "A data line has a pair of y and x values separated by a comma" + "\r\n" + 
                    "A data line can have a weight value that is appended after x and is separated by a comma" + "\r\n" + 
                    "Weights are optional and need to appear when their values are not 1" + "\r\n" + 
                    "A comment line must NOT start with any of the chatacters +-.0123456789" + "\r\n"  + 
                    "Show an example?";
            if (MessageBox.Show(sText, "Help", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == System.Windows.Forms.DialogResult.Yes)
            {
                bEditMode = false;
                sText = "Sample data (example of free form comment line)" + "\r\n" + 
                       "45,32,76" + "\r\n" + "67,34,98" + "\r\n" + 
                       "Next line is an observation that is temporaryly commente dout" + "\r\n" +
                       "! 56,23,44" + "\r\n";
                for (i = 1; i < 11; i++)
                {
                    x1 = (int)(200 * r.NextDouble());
                    x2 = (int)(200 * r.NextDouble());
                    x3 = (int)(200 * r.NextDouble());
                    sText = sText + x1.ToString() + "," + x2.ToString() +  "," + x3.ToString() + "\r\n";
                }
                txtRes.Text = sText;
            }			
		}
	}
	
}
